from panda3d.core import *
         
class setup_gfx():
    def __init__(self, config, manager):        
        #none!
        if config['post-process']=='None' and config['antialiasing']!="FXAA" and config['reflection']==0:
            pass
        #fxaa
        if config['post-process']=='None' and config['antialiasing']=="FXAA" and config['reflection']==0:        
            tex = Texture()
            quad = manager.renderSceneInto(colortex=tex)
            self.makeFXAA(quad, tex, config['win-size'][0], config['win-size'][1])
        #flare
        if config['post-process']=='Lens Flare' and config['antialiasing']!="FXAA" and config['reflection']==0:
            tex1 = Texture()        
            quad = manager.renderSceneInto(colortex=tex1)
            self.makeFlare(manager, quad, tex1)
        #bloom   
        if config['post-process']=='Bloom' and config['antialiasing']!="FXAA" and config['reflection']==0:
            tex1 = Texture()        
            quad = manager.renderSceneInto(colortex=tex1)
            self.makeBloom(manager, quad, tex1)         
        #bloom+flare
        if config['post-process']=='Bloom+Lens Flare' and config['antialiasing']!="FXAA" and config['reflection']==0:
            tex1 = Texture()        
            quad = manager.renderSceneInto(colortex=tex1)
            self.makeFlare(manager, quad, tex1, bloom=True)
        #reflections
        if config['post-process']=='None' and config['antialiasing']!="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
        #fxaa, bloom 
        if config['post-process']=='Bloom' and config['antialiasing']=="FXAA" and config['reflection']==0:
            tex1 = Texture()   
            tex2 = Texture()    
            finalquad = manager.renderSceneInto(colortex=tex1)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeBloom(manager, quad, tex1)
            self.makeFXAA(finalquad, tex2, config['win-size'][0], config['win-size'][1])
        #fxaa, flare
        if config['post-process']=='Lens Flare' and config['antialiasing']=="FXAA" and config['reflection']==0:
            tex1 = Texture()   
            tex2 = Texture()    
            finalquad = manager.renderSceneInto(colortex=tex1)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeFlare(manager, quad, tex1)
            self.makeFXAA(finalquad, tex2, config['win-size'][0], config['win-size'][1])
        #fxaa, reflection
        if config['post-process']=='None' and config['antialiasing']=="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            self.makeFXAA(final_quad, tex2, config['win-size'][0], config['win-size'][1])
        #fxaa, bloom+flare
        if config['post-process']=='Bloom+Lens Flare' and config['antialiasing']=="FXAA" and config['reflection']==0:
            tex1 = Texture()   
            tex2 = Texture()    
            finalquad = manager.renderSceneInto(colortex=tex1)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeFlare(manager, quad, tex1, bloom=True)
            self.makeFXAA(finalquad, tex2, config['win-size'][0], config['win-size'][1])
        #bloom, reflections
        if config['post-process']=='Bloom' and config['antialiasing']!="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            self.makeBloom(manager, final_quad, tex2)
        #flare, reflections
        if config['post-process']=='Lens Flare' and config['antialiasing']!="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            self.makeFlare(manager,final_quad, tex2, bloom=False)
        #bloom+flare, reflections
        if config['post-process']=='Bloom+Lens Flare' and config['antialiasing']!="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            self.makeFlare(manager,final_quad, tex2, bloom=True)
        #fxaa, bloom, reflections 
        if config['post-process']=='Bloom' and config['antialiasing']=="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            tex3=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            quad2=manager.renderQuadInto(colortex=tex3)
            self.makeBloom(manager,quad2, tex2)
            self.makeFXAA(final_quad, tex3, config['win-size'][0], config['win-size'][1])         
        #fxaa, flare, reflections   
        if config['post-process']=='Lens Flare' and config['antialiasing']=="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            tex3=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            quad2=manager.renderQuadInto(colortex=tex3)
            self.makeFlare(manager,quad2, tex2, bloom=False)
            self.makeFXAA(final_quad, tex3, config['win-size'][0], config['win-size'][1])
        #fxaa, bloom+flare, reflections
        if config['post-process']=='Bloom+Lens Flare' and config['antialiasing']=="FXAA" and config['reflection']!=0:
            color_tex = Texture()
            normal_tex = Texture()
            depth_tex = Texture()
            tex2=Texture()
            tex3=Texture()
            final_quad = manager.renderSceneInto(colortex=color_tex, depthtex=depth_tex, auxtex=normal_tex, auxbits=AuxBitplaneAttrib.ABOAuxNormal)
            quad=manager.renderQuadInto(colortex=tex2)
            self.makeSSLR(quad, color_tex, normal_tex, depth_tex, size=512)
            quad2=manager.renderQuadInto(colortex=tex3)
            self.makeFlare(manager,quad2, tex2, bloom=True)
            self.makeFXAA(final_quad, tex3, config['win-size'][0], config['win-size'][1])
        
    def makeSSLR(self, quad, color_tex, normal_tex, depth_tex, size=512):
        print "SSLR on"
        filterBuffer=base.win.makeTextureBuffer("sslr_buff", size, size)
        filterBuffer.setSort(-10)
        filterBuffer.setClearColor(Vec4(1,0,0,1))
        blurCamera=base.makeCamera2d(filterBuffer)
        blurScene=NodePath("sslr scene")
        blurCamera.node().setScene(blurScene)        
        card = base.win.getTextureCard()
        card.reparentTo(blurScene)
        card.setShader(loader.loadShader('shaders/ssr_zfar.cg'))
        card.setShaderInput("albedo", color_tex)
        card.setShaderInput("depth", depth_tex)
        card.setShaderInput("normal", normal_tex)
        card.setShaderInput("mcamera", base.cam)
        
        quad.setShader(Shader.load("shaders/mix.cg"))
        quad.setShaderInput("albedo", color_tex)
        quad.setShaderInput("reflection", filterBuffer.getTexture())
    
    def makeBloom(self, manager, quad, color_tex):
        print "Bloom on"
        tex2=Texture()
        interquad = manager.renderQuadInto(colortex=tex2)
        interquad.setShader(Shader.load("shaders/gaussian_blur_strong.cg"))
        interquad.setShaderInput("tex2", color_tex)
        quad.setShader(Shader.load("shaders/bloom.cg"))
        quad.setShaderInput("tex1", color_tex)            
        quad.setShaderInput("tex2", tex2)
        
    def makeFlare(self, manager, quad, color_tex, bloom=False):
        print "Flare on, bloom ", bloom
        #tex1 = Texture()
        tex2 = Texture()
        tex3 = Texture()
        #finalquad = manager.renderSceneInto(colortex=tex1)            
        interquad = manager.renderQuadInto(colortex=tex2)
        interquad.setShader(Shader.load("shaders/invert_threshold_r_blur.cg"))
        interquad.setShaderInput("tex1", color_tex)
        interquad.setShaderInput("threshold", Vec3(0.92, 0.92, 0.92))            
        interquad2 = manager.renderQuadInto(colortex=tex3)
        interquad2.setShader(Shader.load("shaders/gaussian_blur.cg"))
        interquad2.setShaderInput("tex2", tex2)    
        if bloom:
            quad.setShader(Shader.load("shaders/bloom_flare.cg"))
        else:
            quad.setShader(Shader.load("shaders/lens_flare.cg"))
        quad.setShaderInput("tex1", color_tex)            
        quad.setShaderInput("tex3", tex3)
        
    def makeFXAA(self,quad, tex, width, height):
        print "FXAA on"
        #tex = Texture()
        #    quad = manager.renderSceneInto(colortex=tex)
        quad.setShader(Shader.load(Shader.SLGLSL, "shaders/fxaa_v.glsl", "shaders/fxaa_f.glsl"))
        quad.setShaderInput("tex0", tex)
        quad.setShaderInput("rt_w",float(width))
        quad.setShaderInput("rt_h",float(height))
        quad.setShaderInput("FXAA_SPAN_MAX" , 8.0)
        quad.setShaderInput("FXAA_REDUCE_MUL", 1.0/8.0)
        quad.setShaderInput("FXAA_SUBPIX_SHIFT", 1.0/4.0)        