from panda3d.core import *
from direct.gui.DirectGui import *

class HiScore():        
    def __init__(self):  
        self.total_score=0
        self.current_score=0
        self.current_multiplier=1
        self.font = loader.loadFont('font/font.ttf')
        self.font.setPixelsPerUnit(30)
        self.scoreFrame = DirectFrame(frameSize=(-200, 0, 0, 200),
                                    frameColor=(0, 0, 0, 1),                                    
                                    parent=pixel2d)         
        self.scoreFrame.setPos(200,0,-50)
        
        self.label1=DirectLabel(text = 'SCORE: 00000',
                                frameColor=(0, 0, 0, 0),
                                text_font=self.font,                                
                                text_scale = 30,
                                text_fg=(1,1,1,1),                                
                                text_align=TextNode.ALeft, 
                                textMayChange=1,
                                parent=pixel2d
                                )
        self.label1.setPos(0,0,-26)
        self.label2=DirectLabel(text = '+ 1x 0',
                                frameColor=(0, 0, 0, 0),
                                text_font=self.font,                                
                                text_scale = 20,
                                text_fg=(1,1,1,1),                                
                                text_align=TextNode.ALeft, 
                                textMayChange=1,
                                parent=pixel2d
                                )
        self.label2.setPos(110,0,-45)
        
    def Update(self):
        self.label1['text']="SCORE: {0:05d}".format(self.total_score)
        self.label2['text']="+ {0}x {1}".format(self.current_multiplier, self.current_score)
        
    def Bank(self): 
        self.total_score+=self.current_score*self.current_multiplier
        self.current_score=0
        self.current_multiplier=1
        self.Update()
        
    def Multiplier(self, number):    
        self.current_multiplier=number
        self.Update()
        
    def Set(self, number):
        self.current_score=number
        self.Update()
        